<template>
  <div id="chart-top-10-users" style="height: 200px"></div>
</template>

<script>
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
am4core.useTheme(am4themes_animated);

export default {
  mounted() {
    this.createChartTop10Users();
  },
  methods: {
    createChartTop10Users() {
      var chartUsers = am4core.create("chart-top-10-users", am4charts.XYChart);
      chartUsers.hiddenState.properties.opacity = 0;
      chartUsers.paddingBottom = 30;
      chartUsers.data = [
        {
          name: "Camila",
          steps: 92,
        },
        {
          name: "João Paulo",
          steps: 90,
        },
        {
          name: "Alex",
          steps: 88,
        },
        {
          name: "Danila",
          steps: 87,
        },
        {
          name: "Monica",
          steps: 85,
        },
        {
          name: "Jorge",
          steps: 84,
        },
        {
          name: "Lucas",
          steps: 83,
        },
        {
          name: "Ana",
          steps: 78,
        },
        {
          name: "Raquel",
          steps: 77,
        },
        {
          name: "Junior",
          steps: 75,
        },
      ];

      var categoryAxis = chartUsers.xAxes.push(new am4charts.CategoryAxis());
      categoryAxis.dataFields.category = "name";
      categoryAxis.renderer.grid.template.strokeOpacity = 0;
      categoryAxis.renderer.minGridDistance = 10;
      categoryAxis.renderer.labels.template.dy = 10;
      categoryAxis.renderer.tooltip.dy = 35;

      var valueAxis = chartUsers.yAxes.push(new am4charts.ValueAxis());
      valueAxis.renderer.inside = true;
      valueAxis.renderer.labels.template.fillOpacity = 0.3;
      valueAxis.renderer.grid.template.strokeOpacity = 0;
      valueAxis.min = 0;
      valueAxis.cursorTooltipEnabled = false;
      valueAxis.renderer.baseGrid.strokeOpacity = 0;

      var series = chartUsers.series.push(new am4charts.ColumnSeries());
      series.dataFields.valueY = "steps";
      series.dataFields.categoryX = "name";
      series.tooltipText = "{valueY.value}";
      series.tooltip.pointerOrientation = "vertical";
      series.tooltip.dy = -6;
      series.columnsContainer.zIndex = 100;

      var columnTemplate = series.columns.template;
      columnTemplate.width = am4core.percent(50);
      columnTemplate.maxWidth = 5;
      columnTemplate.column.cornerRadius(50, 50, 10, 10);
      columnTemplate.strokeOpacity = 0;

      series.heatRules.push({
        target: columnTemplate,
        property: "fill",
        dataField: "valueY",
        min: am4core.color("#f2f3f5"),
        max: am4core.color("#1890ff"),
      });
      series.mainContainer.mask = undefined;

      var cursor = new am4charts.XYCursor();
      chartUsers.cursor = cursor;
      cursor.lineX.disabled = true;
      cursor.lineY.disabled = true;
      cursor.behavior = "none";

      var bullet = columnTemplate.createChild(am4charts.CircleBullet);
      bullet.circle.radius = 12;
      bullet.valign = "bottom";
      bullet.align = "center";
      bullet.isMeasured = true;
      bullet.mouseEnabled = false;
      bullet.verticalCenter = "bottom";

      var outlineCircle = bullet.createChild(am4core.Circle);
      outlineCircle.adapter.add("radius", function (radius, target) {
        var circleBullet = target.parent;
        return circleBullet.circle.pixelRadius + 3;
      });

      var image = bullet.createChild(am4core.Image);
      image.width = 30;
      image.height = 30;
      image.horizontalCenter = "middle";
      image.verticalCenter = "middle";

      image.adapter.add("href", function (href, target) {
        var dataItem = target.dataItem;
        if (dataItem) {
          return "https://instagram.fbsb10-1.fna.fbcdn.net/v/t51.2885-19/s320x320/82982028_616137672537045_7063013215067701248_n.jpg?_nc_ht=instagram.fbsb10-1.fna.fbcdn.net&_nc_ohc=rrN7Va-0lDcAX8wVM8w&oh=0925c9a34930bdce27f2808519b4e197&oe=5F62CEAD";
        }
      });

      image.adapter.add("mask", function (mask, target) {
        var circleBullet = target.parent;
        return circleBullet.circle;
      });

      var previousBullet;
      chartUsers.cursor.events.on("cursorpositionchanged", function () {
        var dataItem = series.tooltipDataItem;

        if (dataItem.column) {
          var bullet = dataItem.column.children.getIndex(1);

          if (previousBullet && previousBullet != bullet) {
            previousBullet.isHover = false;
          }

          if (previousBullet != bullet) {
            var hs = bullet.states.getKey("hover");
            hs.properties.dy = -bullet.parent.pixelHeight + 30;
            bullet.isHover = true;

            previousBullet = bullet;
          }
        }
      });
    },
  },

  beforeDestroy() {
    if (this.chartUsers) {
      this.chartUsers.dispose();
    }
  },
};
</script>
